﻿Public Class Form1
    ' A delegate that represents a method that adds something to the ListBox.
    Private Delegate Sub AddToListDelegate()

    ' Specific methods that match the delegate.
    Private Sub MethodA()
        lstResults.Items.Add("    This is MethodA")
    End Sub

    Private Sub MethodB()
        lstResults.Items.Add("    This is MethodB")
    End Sub

    ' Define and use three delegates.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Define delegate variables.
        Dim A As AddToListDelegate = AddressOf MethodA
        Dim B As AddToListDelegate = AddressOf MethodB
        Dim C As AddToListDelegate = _
            DirectCast([Delegate].Combine(A, B), AddToListDelegate)

        ' Use the delegates.
        lstResults.Items.Add("Calling A:")
        A()
        lstResults.Items.Add("Calling B:")
        B()
        lstResults.Items.Add("Calling C:")
        C()
        lstResults.Items.Add("Calling C - A:")
        C = DirectCast([Delegate].Remove(C, A), AddToListDelegate)
        C()
    End Sub
End Class
